﻿using System;
using Layer2.SharePoint.UI.Administration.Lists;
using Microsoft.SharePoint;

namespace Layer2.Products.BdlcApiExamples
{
    class EnableBdlcInList
    {
        public static void CreateAndEnable(SPWeb web, string listName, bool enableWriteBack, string connectionstring,
                   string connectionProvider, string selectStatement, string primaryKey, string interval, DateTime nextRun)
        {
            Guid listId = web.Lists.Add(listName, string.Empty, SPListTemplateType.GenericList);
            SPList list = web.Lists[listId];
            list.OnQuickLaunch = true;
            list.Update();

            ListSettings listSettings = new ListSettings
                                        {
                                            ConnectionString = connectionstring,
                                            SelectStatement = selectStatement,
                                            UseWriteBack = enableWriteBack,
                                            Provider = connectionProvider,
                                            PrimaryKeys = primaryKey,
                                            WebId = web.ID,
                                            ListId = list.ID,
                                            Interval = interval,
                                            NextRun = nextRun
                                        };

            var businessDataListConnectorLogic = new BusinessDataListConnectorLogic();
            businessDataListConnectorLogic.Init(web, list, listSettings);
            businessDataListConnectorLogic.ExpandList();
            businessDataListConnectorLogic.SaveSettings();
            businessDataListConnectorLogic.EnableOrDisableWriteBack(listSettings.UseWriteBack);
        }

        public static void Enable(SPWeb web, SPList list, bool enableWriteBack, string connectionstring,
                  string connectionProvider, string selectStatement, string primaryKey, string interval, DateTime nextRun)
        {
            ListSettings listSettings = new ListSettings
            {
                ConnectionString = connectionstring,
                SelectStatement = selectStatement,
                UseWriteBack = enableWriteBack,
                Provider = connectionProvider,
                PrimaryKeys = primaryKey,
                WebId = web.ID,
                ListId = list.ID,
                Interval = interval,
                NextRun = nextRun
            };

            var businessDataListConnectorLogic = new BusinessDataListConnectorLogic();
            businessDataListConnectorLogic.Init(web, list, listSettings);
            businessDataListConnectorLogic.ExpandList();
            businessDataListConnectorLogic.SaveSettings();
            businessDataListConnectorLogic.EnableOrDisableWriteBack(listSettings.UseWriteBack);
        }
    }
}
