﻿using System;
using System.Collections.Generic;
using Layer2.SharePoint.UI.Administration.Lists;
using Microsoft.SharePoint;

namespace Layer2.Products.BdlcApiExamples
{
    class UpdateList
    {
        public static string UpdateThisList(SPList list)
        {
            var logic = new BusinessDataListConnectorLogic();
            logic.Init(list);
            return logic.UpdateList();
        }

        public static List<string> UpdateAllListsInSiteCollection(SPSite site)
        {
            List<string> results = new List<string>();
            SPList configurationList = BdlcConfigList.GetList(site.RootWeb);
          
            foreach (SPListItem configItem in configurationList.Items)
            {
                SPWeb bdlcWeb = site.OpenWeb(new Guid(configItem[Constants.WEB_ID].ToString()));
                SPList bdlcList = bdlcWeb.Lists[new Guid(configItem[Constants.LIST_ID].ToString())];
                results.Add(UpdateThisList(bdlcList));
            }
            return results;
        }
      
        /// <summary>
        /// NOTE: This methods simulates the BDLC timer job / background update.
        /// If a list is not configured as "Enable background update", it will be ignored
        /// </summary>
        /// <param name="site"></param>
        /// <returns></returns>
        public static void PerformBackgroundUpdate(SPSite site)
        {
            var logic = new BusinessDataListConnectorLogic();
            logic.UpdateAllLists(site.RootWeb);
        }
    }
}
